Index: trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/SlaveView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/SlaveView.Designer.cs	(revision 7259)
+++ trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/SlaveView.Designer.cs	(revision 7857)
@@ -65,10 +65,12 @@
       this.label3 = new System.Windows.Forms.Label();
       this.txtHbIntervall = new System.Windows.Forms.TextBox();
+      this.cbxDisposable = new System.Windows.Forms.CheckBox();
+      this.label4 = new System.Windows.Forms.Label();
       this.SuspendLayout();
       // 
       // txtSlaveState
       // 
-      this.txtSlaveState.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtSlaveState.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtSlaveState.Enabled = false;
       this.txtSlaveState.Location = new System.Drawing.Point(146, 216);
@@ -79,6 +81,6 @@
       // txtOS
       // 
-      this.txtOS.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtOS.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtOS.Enabled = false;
       this.txtOS.Location = new System.Drawing.Point(146, 190);
@@ -107,6 +109,6 @@
       // txtDetailsDescription
       // 
-      this.txtDetailsDescription.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtDetailsDescription.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtDetailsDescription.Enabled = false;
       this.txtDetailsDescription.Location = new System.Drawing.Point(146, 86);
@@ -126,6 +128,6 @@
       // txtName
       // 
-      this.txtName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtName.Location = new System.Drawing.Point(146, 8);
       this.txtName.Name = "txtName";
@@ -136,6 +138,6 @@
       // txtCPU
       // 
-      this.txtCPU.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtCPU.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtCPU.Enabled = false;
       this.txtCPU.Location = new System.Drawing.Point(146, 112);
@@ -146,6 +148,6 @@
       // txtMemory
       // 
-      this.txtMemory.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtMemory.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtMemory.Enabled = false;
       this.txtMemory.Location = new System.Drawing.Point(146, 138);
@@ -156,6 +158,6 @@
       // txtLastHeartbeat
       // 
-      this.txtLastHeartbeat.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtLastHeartbeat.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtLastHeartbeat.Enabled = false;
       this.txtLastHeartbeat.Location = new System.Drawing.Point(146, 242);
@@ -211,6 +213,6 @@
       // txtFreeMemory
       // 
-      this.txtFreeMemory.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtFreeMemory.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtFreeMemory.Enabled = false;
       this.txtFreeMemory.Location = new System.Drawing.Point(146, 164);
@@ -221,6 +223,6 @@
       // txtId
       // 
-      this.txtId.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtId.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtId.Enabled = false;
       this.txtId.Location = new System.Drawing.Point(146, 60);
@@ -249,6 +251,6 @@
       // txtHbIntervall
       // 
-      this.txtHbIntervall.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtHbIntervall.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.txtHbIntervall.Location = new System.Drawing.Point(146, 34);
       this.txtHbIntervall.Name = "txtHbIntervall";
@@ -257,8 +259,29 @@
       this.txtHbIntervall.TextChanged += new System.EventHandler(this.txtHbIntervall_TextChanged);
       // 
+      // cbxDisposable
+      // 
+      this.cbxDisposable.AutoSize = true;
+      this.cbxDisposable.Location = new System.Drawing.Point(146, 268);
+      this.cbxDisposable.Name = "cbxDisposable";
+      this.cbxDisposable.Size = new System.Drawing.Size(15, 14);
+      this.cbxDisposable.TabIndex = 34;
+      this.cbxDisposable.UseVisualStyleBackColor = true;
+      this.cbxDisposable.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
+      // 
+      // label4
+      // 
+      this.label4.AutoSize = true;
+      this.label4.Location = new System.Drawing.Point(3, 269);
+      this.label4.Name = "label4";
+      this.label4.Size = new System.Drawing.Size(62, 13);
+      this.label4.TabIndex = 35;
+      this.label4.Text = "Disposable:";
+      // 
       // SlaveView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.label4);
+      this.Controls.Add(this.cbxDisposable);
       this.Controls.Add(this.txtHbIntervall);
       this.Controls.Add(this.label3);
@@ -282,5 +305,5 @@
       this.Controls.Add(this.label9);
       this.Name = "SlaveView";
-      this.Size = new System.Drawing.Size(539, 267);
+      this.Size = new System.Drawing.Size(539, 285);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -310,4 +333,6 @@
     private System.Windows.Forms.Label label3;
     private System.Windows.Forms.TextBox txtHbIntervall;
+    private System.Windows.Forms.CheckBox cbxDisposable;
+    private System.Windows.Forms.Label label4;
   }
 }