Index: /trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/SlaveView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/SlaveView.cs	(revision 7861)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/SlaveView.cs	(revision 7862)
@@ -69,5 +69,5 @@
           txtName.Text = ct.Name;
           txtHbIntervall.Text = ct.HbInterval.ToString();
-          cbxDisposable.Checked = ct.IsDisposable;
+          cbxDisposable.Checked = ct.IsDisposable.GetValueOrDefault();
           txtCPU.Text = string.Format("{0} Cores @ {1} Mhz, Arch.: {2}", ct.Cores.ToString(), ct.CpuSpeed.ToString(), ct.CpuArchitecture.ToString());
           txtDetailsDescription.Text = ct.Description;
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs	(revision 7861)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs	(revision 7862)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.269
+//     Runtime Version:4.0.30319.544
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -59,4 +59,6 @@
 
     public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
+
+
   }
 
@@ -967,5 +969,5 @@
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private bool IsDisposableField;
+    private System.Nullable<bool> IsDisposableField;
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -1073,5 +1075,5 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public bool IsDisposable {
+    public System.Nullable<bool> IsDisposable {
       get {
         return this.IsDisposableField;
Index: /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 7861)
+++ /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 7862)
@@ -55,5 +55,5 @@
         <Column Name="LastHeartbeat" Type="System.DateTime" DbType="DateTime" CanBeNull="true" />
         <Column Name="CpuUtilization" Type="System.Double" DbType="float" CanBeNull="false" />
-        <Column Name="IsDisposable" Type="System.Boolean" DbType="Bit" CanBeNull="false" />
+        <Column Name="IsDisposable" Type="System.Boolean" DbType="Bit" CanBeNull="true" />
       </Type>
       <Type Name="SlaveGroup" InheritanceCode="GROUP" />
Index: /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml.layout
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml.layout	(revision 7861)
+++ /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml.layout	(revision 7862)
@@ -179,5 +179,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(7.5 : 4.30930826822917); (7.5 : 4.876650890625); (8.875 : 4.876650890625)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(7.5 : 4.30930826822917); (7.5 : 4.876650890625); (7.97916666666667 : 4.876650890625 : JumpStart); (8.14583333333333 : 4.876650890625 : JumpEnd); (8.875 : 4.876650890625)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Task/Task_AssignedResource" />
       <nodes>
Index: /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 7861)
+++ /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 7862)
@@ -3,5 +3,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.269
+//     Runtime Version:4.0.30319.544
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -1179,5 +1179,5 @@
 		private double _CpuUtilization;
 		
-		private bool _IsDisposable;
+		private System.Nullable<bool> _IsDisposable;
 		
     #region Extensibility Method Definitions
@@ -1209,5 +1209,5 @@
     partial void OnCpuUtilizationChanging(double value);
     partial void OnCpuUtilizationChanged();
-    partial void OnIsDisposableChanging(bool value);
+    partial void OnIsDisposableChanging(System.Nullable<bool> value);
     partial void OnIsDisposableChanged();
     #endregion
@@ -1459,5 +1459,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IsDisposable", DbType="Bit")]
-		public bool IsDisposable
+		public System.Nullable<bool> IsDisposable
 		{
 			get
Index: /trunk/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Slave.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Slave.cs	(revision 7861)
+++ /trunk/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Slave.cs	(revision 7862)
@@ -54,5 +54,5 @@
     public double CpuUtilization { get; set; }
     [DataMember]
-    public bool IsDisposable { get; set; }
+    public bool? IsDisposable { get; set; }
 
     public Slave() {
Index: /trunk/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 7861)
+++ /trunk/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 7862)
@@ -122,5 +122,5 @@
     /// </summary>
     private void DeleteObsoleteSlaves() {
-      var slaves = dao.GetSlaves(x => x.IsDisposable && x.SlaveState == SlaveState.Offline && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.SweepInterval);
+      var slaves = dao.GetSlaves(x => x.IsDisposable.GetValueOrDefault() && x.SlaveState == SlaveState.Offline && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.SweepInterval);
       foreach (DT.Slave slave in slaves) dao.DeleteSlave(slave.Id);
     }